global function Phasedash_Settings_Init
#if SERVER
global function stuck
#endif

void function Phasedash_Settings_Init() {
    #if SERVER
    AddClientCommandCallback("!stuck",stuckfunc)
	AddClientCommandCallback("!version",versioncheckfunc)

	AddCallback_OnClientConnected(OnClientConnected)

    PrecacheModel( $"models/fx/core_energy.mdl")
    #endif

    AddPrivateMatchModeSettingEnum("#MODE_SETTING_CATEGORY_PhaseBoost", "#Enable_Phase_Rewind", ["#SETTING_DISABLED", "#SETTING_ENABLED"], "1")
    AddPrivateMatchModeSettingEnum("#MODE_SETTING_CATEGORY_PhaseBoost", "#Boost_Strength", ["#SETTING_Normal", "#SETTING_Boosted", "#SETTING_Extreme"], "0")
    AddPrivateMatchModeSettingArbitrary("#MODE_SETTING_CATEGORY_PhaseBoost", "#Boost_Cooldown", "5" )

}

#if SERVER
void function stuck (entity player) {
	vector pos = FindNearestSafePos(player , player.GetOrigin() , 1)

	entity mover = CreateOwnedScriptMover (player)
	player.SetParent(mover)
	mover.NonPhysicsMoveTo (pos, 0.1,0,0)
	wait 0.3;
	player.SetVelocity(<0,0,0>)
	player.ClearParent()
	mover.Destroy()

}



bool function stuckfunc (entity player , array<string> args) {thread stuck(player);return true;}
bool function versioncheckfunc (entity player , array<string> args) {print(phasemodversion);return true;}







void function OnClientConnected(entity player) { //table init
	string playername = player.GetPlayerName()
	playerrewindusedtable[playername] <- false;
	playerongoingcounttable[playername] <- false;
}
#endif



